Hilzer's Barbershop Problem
===========================
Hilzer’s Barbershop Probleм претставува покомплицирана верзија на класичниот проблем на берберница (Barbershop Problem).

  Во овој проблем берберницата има повеќе столчиња за потстрижување (исто колку и бербери), повеќе бербери (но не повеќе од 15) и просторија за чекање која се состои од една софа на која може да се сместат најмногу 4 клиенти и простор за стоење. Ограничувањата се дека во берберницата не смее во ниеден момент да има повеќе од 20 клиенти (ова ги вклучува столчињата, софата и просторот за стоење). Од ова ограничување произлегува и ограничувањето за берберите и столчињата, бидејќи секој клиент мора прво да чека стоечки, па да чека седечки, па да оди на столчето за потстрижување, па ако ставиме повеќе од 15 бербери ќе нема место за стоење.

  Клиент не смее да влезе во берберницата ако нејзиниот капацитет е исполнет (внатре веќе има 20 клиенти).  
Откако ќе влезе, клиентот стои додека да се ослободи место на софата (да има помалку од 4 клиенти на софата). 
Кога некој бербер е слободен, еден од клиентите (не е важно кој) кои седат на софата се префрлува на неговото столче за потстрижување и му сигнализира на берберот дека тој е спремен за потстрижување.  
Во овој момент ако има клиенти кои стојат, еден од нив (не е важно кој) седнува на софата.  
Кога некој од клиентите е готов со потстрижувањето тој плака кај било кој од берберите (немора кај тој што го потстрижувал).   Повеќе клиенти може да плаќаат во исто време.  
Берберите своето време го делат помегу: потстрижување, наплаќање и чекање да дојде клиент на нивото столче.  

Со други зборови, следниве ограничувања треба да важат при синхронизацијата: 
+ Клиентите ги повикуваат следниве функции и тоа стрикно во овој редослед: **enterShop**,  **sitOnSofa**,  **sitInBarberChair**, **getHairCut**, **pay**, **exitShop**. 
+ Берберите ги повикуваат: **cutHair**, **acceptPayment**.

#### -   enterShop()
+ Секој клиент ја повикува при влез во берберницата.
+ Клиентите не може да ја повикаат enterShop ако капацитетот на берберницата е исполнет. 

---
#### -   sitOnSofa()
+ Секој клиент ја повикува при седнување на софата.
+ Највеќе 4 клиенти можат да седат на софата истовремено.
+ Ако капацитетот на софата е полн, клиент којшто пристигнал не може да ја повика **sitOnSofa** додека еден од клиентите на софата не ја повика **sitInBarberChair**. 

---
#### -   sitInBarberChair()
+ Секој клиент ја повикува при седнување на берберскиот стол.
+ Ако сите бербер(и) се зафатени, клиентот не може да ја повика **sitInBarberChair** додека еден од клиентите кои се потстрижуваат не ја повика **exitShop**. 

---
#### -   getHairCut()
+ Секој клиент ја повикува по седнувањето на берберскиот стол.
+ Мора да биде повикана пред берберот да ја повика **cutHair**.

---
#### -   pay()
+ Секој клиент ја повикува откако ке биде потстрижан.
+ Клиентот мора да ја повика pay пред берберот да  ја повика acceptPayment. 
+ Клиентот не може да ја повика **exitShop** пред да плати.

---
#### -   exitShop()
+ Секој клиент мора да бил потстрижан пред да може да излезе.
+ Берберот мора да ја повика acceptPayment пред клиентот да ја повика exitShop. 

---
---

#### -   cutHair()
+ Секој бербер ја повикува кога ќе има присутен клиент на некој од столовите.
+ Клиентот мора да ја повикал **getHairCut** пред да биде повикана оваа функција.

---
#### -   acceptPayment()
+ Секој бербер ја повикува по потстрижувањето на клиент.
+ Клиентот мора да ја повикал **pay** пред да биде повикана оваа функција.

---

**Ниедна од функциите не смее да се повика повеќе од еднаш и вон дадениот редослед.**  
Се користат семафори и бројачи по желба. Тие треба да се дефинитат на почетокот од класата и треба да се static.  
Се иницијализираат во методот **init()**.  
Треба да се имплементираат методите execute() во секоја од двете класи (Barber и Customer) користејќи ги претходно споменатите методи.  
Не смеат да се користат try-catch блокови во **execute()** методите.